;;; ctrl-move.el
;;; By Greg J. Badros -- Jan 1995
;;; $Id: ctrl-move.el,v 1.3 1995/02/18 07:57:24 gjb Exp $

(defvar kill-ring-temp 'nil
  "Temporary storage for the kill-ring")
(defvar kill-ring-yank-pointer-temp 'nil
  "Temporary storage for the kil-ring-yank-pointer")

(defun move-line-up ()
  "Move the current line up.
i.e. Switch it with the line above."
  (interactive)
  (setq kill-ring-temp kill-ring)
  (setq kill-ring-yank-pointer-temp kill-ring-yank-pointer)
  (save-excursion
    (beginning-of-line)
    (kill-line)
    (forward-line -1)
    (yank))
  (setq kill-ring kill-ring-temp)
  (setq kill-ring-yank-pointer kill-ring-yank-pointer-temp)
  (forward-line -2))

(defun move-line-down ()
  "Move the current line down.
i.e. Switch it with the line below"
  (interactive)
  (setq kill-ring-temp kill-ring)
  (setq kill-ring-yank-pointer-temp kill-ring-yank-pointer)
  (save-excursion
    (beginning-of-line)
    (kill-line)
    (forward-line 1)
    (yank))
  (setq kill-ring kill-ring-temp)
  (setq kill-ring-yank-pointer kill-ring-yank-pointer-temp)
  (forward-line 1))

(setq kill-whole-line 't)

(define-key global-map [C-down] 'move-line-down)
(define-key global-map [C-up] 'move-line-up)
