(defmacro looking-at-prototype ()
  "Evaluates to t iff we're looking-at a regexp that matches\
a fn prototype"
  (looking-at ""))


(defun convert-proto-to-memfn (fMemberFn)
  "Converts a class fn prototype to a member fn for a .cc file"
  (interactive "p")
  (beginning-of-line)
  ;;;;;;;;;;;;;;;;;;;;;;qualifiers                         [return_type *]      FnName (
  (if (not (looking-at "^\\s *\\(virtual\\|static\\)?\\s *\\(\\w+\\s *\\*?\\)?\\s *\\(~?\\|operator\\s *\\)?\\w+.*("))
      (message "Not on line with prototype.")
    (if (looking-at "\\s *\\(virtual\\|static\\)?\\s *")
	(delete-char (- (match-end 0) (match-beginning 0))))
    (string-match "[^\\.]+" (buffer-name))
    (setq classname (substring (buffer-name) (match-beginning 0) (match-end 0)))
    (if (string= (substring (buffer-name) -4) ".inl")
	(progn (insert "inline\n")))
    (re-search-forward "\\(~?\\|operator\\s *\\)?\\w+\\s *\(")
    (save-excursion
      (goto-char (match-beginning 0))
      (insert "\n")
      (if (= fMemberFn 1)
	  (insert (concat classname "::")))
      (search-forward "\(")
      (while (looking-at "\\([^=;]*\\)\\s *=[^;,)]*\\(,?\\)")
	(replace-match "\\1\\2"))
      (search-forward ";")
    (delete-char -1)
    (insert "\n\{\n\n\}")
    (forward-line -1)
    (c-indent-command))
    (beginning-of-line)
    (forward-line -1)
    (if (looking-at "\\s *\n")
      (kill-line 1))
    (indent-paragraph)
    (re-search-forward "^\\s *\\{")
    (forward-line 1)
    (c-indent-command)))



(defun indent-paragraph ()
  "Indent around the point, bounded by paragraphs"
  (interactive)
  (save-excursion
    (mark-paragraph)
    (indent-region  (point) (mark) nil)))
